Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1411053 - Review Request: nodejs-jschardet - Character encoding auto-detection in JavaScript (port of python's chardet)
Summary: Review Request: nodejs-jschardet - Character encoding auto-detection in JavaS...
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Tom Hughes
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: nodejs-reviews Node-RED 1411054
TreeView+ depends on / blocked
 
Reported: 2017-01-07 21:45 UTC by Jared Smith
Modified: 2017-04-07 15:43 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-04-07 15:43:10 UTC
tom: fedora-review+


Attachments (Terms of Use)

Description Jared Smith 2017-01-07 21:45:54 UTC
Spec URL: https://jsmith.fedorapeople.org/Packaging/nodejs-jschardet/nodejs-jschardet.spec
SRPM URL: https://jsmith.fedorapeople.org/Packaging/nodejs-jschardet/nodejs-jschardet-1.4.1-1.fc26.src.rpm
Description: Character encoding auto-detection in JavaScript (port of python's chardet)
Fedora Account System Username: jsmith

Comment 1 kaiwang 2017-02-22 07:23:57 UTC
*This is un-official review of the package.*

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "LGPL (v2.1 or later)", "Unknown or generated". 10 files have
     unknown license. Detailed output of licensecheck in
     /home/kermit/review/1411053-nodejs-jschardet/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: nodejs-jschardet-1.4.1-1.fc26.noarch.rpm
          nodejs-jschardet-1.4.1-1.fc26.src.rpm
nodejs-jschardet.noarch: W: spelling-error Summary(en_US) chardet -> charted, charade, chard
nodejs-jschardet.noarch: W: spelling-error %description -l en_US chardet -> charted, charade, chard
nodejs-jschardet.noarch: W: only-non-binary-in-usr-lib
nodejs-jschardet.src: W: spelling-error Summary(en_US) chardet -> charted, charade, chard
nodejs-jschardet.src: W: spelling-error %description -l en_US chardet -> charted, charade, chard
2 packages and 0 specfiles checked; 0 errors, 5 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
nodejs-jschardet.noarch: W: spelling-error Summary(en_US) chardet -> charted, charade, chard
nodejs-jschardet.noarch: W: spelling-error %description -l en_US chardet -> charted, charade, chard
nodejs-jschardet.noarch: W: only-non-binary-in-usr-lib
1 packages and 0 specfiles checked; 0 errors, 3 warnings.



Requires
--------
nodejs-jschardet (rpmlib, GLIBC filtered):
    /usr/bin/node
    nodejs
    nodejs(engine)



Provides
--------
nodejs-jschardet:
    nodejs-jschardet
    npm(jschardet)



Source checksums
----------------
https://registry.npmjs.org/jschardet/-/jschardet-1.4.1.tgz :
  CHECKSUM(SHA256) this package     : e55673ff0393d0c7c9152c954e20d7824a8c09f0712132d82137d9393da3cb7c
  CHECKSUM(SHA256) upstream package : e55673ff0393d0c7c9152c954e20d7824a8c09f0712132d82137d9393da3cb7c


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1411053 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 2 Tom Hughes 2017-02-25 15:47:52 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "LGPL (v2.1 or later)", "Unknown or generated". 10 files have
     unknown license. Detailed output of licensecheck in /home/tom/1411053
     -nodejs-jschardet/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[!]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[!]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: nodejs-jschardet-1.4.1-1.fc26.noarch.rpm
          nodejs-jschardet-1.4.1-1.fc26.src.rpm
nodejs-jschardet.noarch: W: spelling-error Summary(en_US) chardet -> charted, charade, chard
nodejs-jschardet.noarch: W: spelling-error %description -l en_US chardet -> charted, charade, chard
nodejs-jschardet.noarch: W: only-non-binary-in-usr-lib
nodejs-jschardet.src: W: spelling-error Summary(en_US) chardet -> charted, charade, chard
nodejs-jschardet.src: W: spelling-error %description -l en_US chardet -> charted, charade, chard
2 packages and 0 specfiles checked; 0 errors, 5 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
nodejs-jschardet.noarch: W: spelling-error Summary(en_US) chardet -> charted, charade, chard
nodejs-jschardet.noarch: W: spelling-error %description -l en_US chardet -> charted, charade, chard
nodejs-jschardet.noarch: W: only-non-binary-in-usr-lib
1 packages and 0 specfiles checked; 0 errors, 3 warnings.



Requires
--------
nodejs-jschardet (rpmlib, GLIBC filtered):
    /usr/bin/node
    nodejs
    nodejs(engine)



Provides
--------
nodejs-jschardet:
    nodejs-jschardet
    npm(jschardet)



Source checksums
----------------
https://registry.npmjs.org/jschardet/-/jschardet-1.4.1.tgz :
  CHECKSUM(SHA256) this package     : e55673ff0393d0c7c9152c954e20d7824a8c09f0712132d82137d9393da3cb7c
  CHECKSUM(SHA256) upstream package : e55673ff0393d0c7c9152c954e20d7824a8c09f0712132d82137d9393da3cb7c


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -m compton-rawhide-x86_64 -b 1411053
Buildroot used: compton-rawhide-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 3 Tom Hughes 2017-02-25 15:52:32 UTC
There's no need to require nodejs explicitly we an automatic require on nodejs(engine) will be added anyway.

The execute bits should be removed from the files in the src directory.

We should probably remove the bundled qunit (tests/qunit) in %prep.

Obviously we can't run the tests until we have the qunit command line test runner in but for the sake of documentation the command needed is:

qunit -c jschardet:src/init.js -t tests/jschardet.js

Note that the "module" line in tests/jschardet.js needs patching to QUnit.module for use in nodejs as "module" at the top level is reserved to node. Also all the "equals" calls produce deprecation warnings (and cause failures) so need patch to "equal" instead. With all that I get 5 failures:

Module: jschardet Test: ISO-2022-CN
    at Object.<anonymous> (/home/thh/rpm/BUILD/package/tests/jschardet.js:111:5)
Actual value:
null
Expected value:
ISO-2022-CN

Module: jschardet Test: windows-1250 (Hungarian)
    at Object.<anonymous> (/home/thh/rpm/BUILD/package/tests/jschardet.js:129:5)
Actual value:
null
Expected value:
windows-1250

Module: jschardet Test: windows-1251 (Bulgarian)
    at Object.<anonymous> (/home/thh/rpm/BUILD/package/tests/jschardet.js:141:5)
Actual value:
ISO-8859-5
Expected value:
windows-1251

Module: jschardet Test: windows-1253 (Greek)
    at Object.<anonymous> (/home/thh/rpm/BUILD/package/tests/jschardet.js:154:5)
Actual value:
null
Expected value:
windows-1253

Module: jschardet Test: EUC-CN
    at Object.<anonymous> (/home/thh/rpm/BUILD/package/tests/jschardet.js:190:5)
Actual value:
null
Expected value:
EUC-CN

I haven't looked at them in any detail.

Comment 4 Jared Smith 2017-03-26 00:18:17 UTC
I've fixed up some of the items above -- but haven't fixed all the errors in the tests.

Spec URL: https://jsmith.fedorapeople.org/Packaging/nodejs-jschardet/nodejs-jschardet.spec
SRPM URL: https://jsmith.fedorapeople.org/Packaging/nodejs-jschardet/nodejs-jschardet-1.4.2-1.fc27.src.rpm

Comment 5 Tom Hughes 2017-03-26 16:36:14 UTC
The BR when tests are enabled should be qunit not mocha but other than that it looks good now.

Comment 6 Gwyn Ciesla 2017-03-29 13:39:02 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/nodejs-jschardet


Note You need to log in before you can comment on or make changes to this bug.